﻿using System.IO;
using UnityEditor;
using UnityEngine;
using Object = UnityEngine.Object;

public class W3Settings : ScriptableObject
{
    private const string path = "Assets/Importers/Warcraft 3/Editor/Settings.asset";
    private static W3Settings _instance;

    public static W3Settings Get()
    {
        if (_instance == null)
            _instance = LoadAsset();
        return _instance;
    }

    public void RegisterObject(Object obj)
    {
        AssetDatabase.AddObjectToAsset(obj, _instance);
    }

    public void Refresh()
    {
        AssetDatabase.Refresh();
        _instance = LoadAsset();
    }

    private static W3Settings LoadAsset()
    {
        var obj = AssetDatabase.LoadAssetAtPath(path, typeof(W3Settings)) as W3Settings;
        if (obj == null)
        {
            var directory = Path.GetDirectoryName(path);
            if (directory != null && !Directory.Exists(directory))
                Directory.CreateDirectory(directory);
            obj = CreateInstance<W3Settings>();
            AssetDatabase.CreateAsset(obj, path);
        }
        return obj;
    }
}