﻿using System;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;

public sealed class css
{
    internal GUILayoutOption[] option = null;
    internal Action<GUIStyle> styleChanged = null;
    internal Func<string, string> contentString = null;
    internal Action actionBeforeElement = null;
    internal Action actionAfterElement = null;
    internal Action actionCapsuleElement = null;
    internal css[] options;
    internal Dictionary<string, object> advanced;

    private css AddAdvanced(string key, object item)
    {
        if (advanced == null)
            advanced = new Dictionary<string, object>();
        if (advanced.ContainsKey(key))
            advanced[key] = item;
        else
            advanced.Add(key, item);
        return this;
    }

    internal object GetAdvanced(string key)
    {
        if (advanced == null)
            return null;
        if (advanced.ContainsKey(key))
            return advanced[key];
        return null;
    }

    private css(params GUILayoutOption[] option)
    {
        this.option = option;
    }

    private css(Action<GUIStyle> styleChanged)
    {
        this.styleChanged = styleChanged;
    }

    private css(Action<GUIStyle> styleChanged, params GUILayoutOption[] option)
    {
        this.option = option;
        this.styleChanged = styleChanged;
    }

    private css(Func<string, string> funcStr)
    {
        contentString = funcStr;
    }

    private css() {}

    //padding:
    public static css padding(int top_right_bottom_left)
    {
        return new css(x => x.padding = new RectOffset(top_right_bottom_left, top_right_bottom_left, top_right_bottom_left, top_right_bottom_left));
    }

    public static css padding(int top_bottom, int left_right)
    {
        return new css(x => x.padding = new RectOffset(left_right, left_right, top_bottom, top_bottom));
    }

    public static css padding(int top, int left_right, int bottom)
    {
        return new css(x => x.padding = new RectOffset(left_right, left_right, top, bottom));
    }

    public static css padding(int top, int right, int bottom, int left)
    {
        return new css(x => x.padding = new RectOffset(left, right, top, bottom));
    }

    public static css padding_left(int left)
    {
        return new css(x => x.padding.left = left);
    }

    public static css padding_right(int right)
    {
        return new css(x => x.padding.right = right);
    }

    public static css padding_top(int top)
    {
        return new css(x => x.padding.top = top);
    }

    public static css padding_bottom(int bottom)
    {
        return new css(x => x.padding.bottom = bottom);
    }

    public static css padding_horizontal(int leftRight)
    {
        return new css(x =>
        {
            x.padding.left = leftRight;
            x.padding.right = leftRight;
        });
    }

    public static css padding_vertical(int topBottom)
    {
        return new css(x =>
        {
            x.padding.top = topBottom;
            x.padding.bottom = topBottom;
        });
    }

    public static css padding_horizontal(int left, int right)
    {
        return new css(x =>
        {
            x.padding.left = left;
            x.padding.right = right;
        });
    }

    public static css padding_vertical(int top, int bottom)
    {
        return new css(x =>
        {
            x.padding.top = top;
            x.padding.bottom = bottom;
        });
    }

    //margin:
    public static css margin(int top_right_bottom_left)
    {
        return new css(x => x.margin = new RectOffset(top_right_bottom_left, top_right_bottom_left, top_right_bottom_left, top_right_bottom_left));
    }

    public static css margin(int top_bottom, int left_right)
    {
        return new css(x => x.margin = new RectOffset(left_right, left_right, top_bottom, top_bottom));
    }

    public static css margin(int top, int left_right, int bottom)
    {
        return new css(x => x.margin = new RectOffset(left_right, left_right, top, bottom));
    }

    public static css margin(int top, int right, int bottom, int left)
    {
        return new css(x => x.margin = new RectOffset(left, right, top, bottom));
    }

    public static css margin_left(int left)
    {
        return new css(x => x.margin.left = left);
    }

    public static css margin_right(int right)
    {
        return new css(x => x.margin.right = right);
    }

    public static css margin_top(int top)
    {
        return new css(x => x.margin.top = top);
    }

    public static css margin_bottom(int bottom)
    {
        return new css(x => x.margin.bottom = bottom);
    }

    public static css margin_horizontal(int leftRight)
    {
        return new css(x =>
        {
            x.margin.left = leftRight;
            x.margin.right = leftRight;
        });
    }

    public static css margin_vertical(int topBottom)
    {
        return new css(x =>
        {
            x.margin.top = topBottom;
            x.margin.bottom = topBottom;
        });
    }

    public static css margin_horizontal(int left, int right)
    {
        return new css(x =>
        {
            x.margin.left = left;
            x.margin.right = right;
        });
    }

    public static css margin_vertical(int top, int bottom)
    {
        return new css(x =>
        {
            x.margin.top = top;
            x.margin.bottom = bottom;
        });
    }

    //border:
    public static css border(int top_right_bottom_left)
    {
        return new css(x => x.border = new RectOffset(top_right_bottom_left, top_right_bottom_left, top_right_bottom_left, top_right_bottom_left));
    }

    public static css border(int top_bottom, int left_right)
    {
        return new css(x => x.border = new RectOffset(left_right, left_right, top_bottom, top_bottom));
    }

    public static css border(int top, int left_right, int bottom)
    {
        return new css(x => x.border = new RectOffset(left_right, left_right, top, bottom));
    }

    public static css border(int top, int right, int bottom, int left)
    {
        return new css(x => x.border = new RectOffset(left, right, top, bottom));
    }

    public static css border_left(int left)
    {
        return new css(x => x.border.left = left);
    }

    public static css border_right(int right)
    {
        return new css(x => x.border.right = right);
    }

    public static css border_top(int top)
    {
        return new css(x => x.border.top = top);
    }

    public static css border_bottom(int bottom)
    {
        return new css(x => x.border.bottom = bottom);
    }

    public static css border_horizontal(int leftRight)
    {
        return new css(x =>
        {
            x.border.left = leftRight;
            x.border.right = leftRight;
        });
    }

    public static css border_vertical(int topBottom)
    {
        return new css(x =>
        {
            x.border.top = topBottom;
            x.border.bottom = topBottom;
        });
    }

    public static css border_horizontal(int left, int right)
    {
        return new css(x =>
        {
            x.border.left = left;
            x.border.right = right;
        });
    }

    public static css border_vertical(int top, int bottom)
    {
        return new css(x =>
        {
            x.border.top = top;
            x.border.bottom = bottom;
        });
    }

    //overflow:
    public static css overflow(int top_right_bottom_left)
    {
        return new css(x => x.overflow = new RectOffset(top_right_bottom_left, top_right_bottom_left, top_right_bottom_left, top_right_bottom_left));
    }

    public static css overflow(int top_bottom, int left_right)
    {
        return new css(x => x.overflow = new RectOffset(left_right, left_right, top_bottom, top_bottom));
    }

    public static css overflow(int top, int left_right, int bottom)
    {
        return new css(x => x.overflow = new RectOffset(left_right, left_right, top, bottom));
    }

    public static css overflow(int top, int right, int bottom, int left)
    {
        return new css(x => x.overflow = new RectOffset(left, right, top, bottom));
    }

    public static css overflow_left(int left)
    {
        return new css(x => x.overflow.left = left);
    }

    public static css overflow_right(int right)
    {
        return new css(x => x.overflow.right = right);
    }

    public static css overflow_top(int top)
    {
        return new css(x => x.overflow.top = top);
    }

    public static css overflow_bottom(int bottom)
    {
        return new css(x => x.overflow.bottom = bottom);
    }

    public static css overflow_horizontal(int leftRight)
    {
        return new css(x =>
        {
            x.overflow.left = leftRight;
            x.overflow.right = leftRight;
        });
    }

    public static css overflow_vertical(int topBottom)
    {
        return new css(x =>
        {
            x.overflow.top = topBottom;
            x.overflow.bottom = topBottom;
        });
    }

    public static css overflow_horizontal(int left, int right)
    {
        return new css(x =>
        {
            x.overflow.left = left;
            x.overflow.right = right;
        });
    }

    public static css overflow_vertical(int top, int bottom)
    {
        return new css(x =>
        {
            x.overflow.top = top;
            x.overflow.bottom = bottom;
        });
    }

    //offset:
    public static css offset_content(int x, int y)
    {
        return new css(z => z.contentOffset = new Vector2(x,y));
    }

    public static css offset_content(int xy)
    {
        return new css(z => z.contentOffset = new Vector2(xy, xy));
    }

    public static css offset_content_x(int x)
    {
        return new css(z => z.contentOffset = new Vector2(x, z.contentOffset.y));
    }

    public static css offset_content_y(int y)
    {
        return new css(z => z.contentOffset = new Vector2(z.contentOffset.x, y));
    }

    //width:
    public static css width(int width)
    {
        return new css(GUILayout.Width(width));
    }

    public static css width_style(int width)
    {
        return new css(x =>
        {
            x.fixedWidth = width;
            x.stretchWidth = false;
        });
    }

    public static css width_stretch(bool stretch)
    {
        return new css(x => x.stretchWidth = stretch);
    }

    public static css width_min(int width)
    {
        return new css(GUILayout.MinWidth(width));
    }

    public static css width_max(int width)
    {
        return new css(GUILayout.MaxWidth(width));
    }

    public static css width_range(int minWidth, int maxWidth)
    {
        return pack(width_min(minWidth), width_max(maxWidth));
    }

    public static css nothing()
    {
        return new css();
    }

    //height:
    public static css height(int height)
    {
        return new css(GUILayout.Height(height));
    }

    public static css height_style(int height)
    {
        return new css(x =>
        {
            x.fixedHeight = height;
            x.stretchHeight = false;
        });
    }

    public static css height_stretch(bool stretch)
    {
        return new css(x => x.stretchHeight = stretch);
    }

    public static css height_min(int height)
    {
        return new css(GUILayout.MinHeight(height));
    }

    public static css height_max(int height)
    {
        return new css(GUILayout.MaxHeight(height));
    }

    public static css height_range(int minHeight, int maxHeight)
    {
        return pack(height_min(minHeight), height_max(maxHeight));
    }

    //expand:
    public static css expand_width(bool expand)
    {
        return new css(
            x =>
            {
                x.fixedWidth = 0;
                x.stretchWidth = expand;
            },
            GUILayout.ExpandWidth(expand)
            );
    }

    public static css expand_width(bool expand, bool stretch)
    {
        return new css(
            x =>
            {
                x.fixedWidth = 0;
                x.stretchWidth = stretch;
            },
            GUILayout.ExpandWidth(expand)
            );
    }


    public static css expand_height(bool expand)
    {
        return new css(
            x =>
            {
                x.fixedHeight = 0;
                x.stretchHeight = expand;
            },
            GUILayout.ExpandHeight(expand)
            );
    }

    public static css expand_height(bool expand, bool stretch)
    {
        return new css(
            x =>
            {
                x.fixedHeight = 0;
                x.stretchHeight = stretch;
            },
            GUILayout.ExpandHeight(expand)
            );
    }


    public static css expand(bool expandHeight, bool expandWidth)
    {
        return new css(
            x =>
            {
                x.fixedHeight = 0;
                x.stretchHeight = expandHeight;
                x.fixedWidth = 0;
                x.stretchWidth = expandWidth;
            },
            GUILayout.ExpandHeight(expandHeight),
            GUILayout.ExpandWidth(expandWidth)
            );
    }

    public static css expand(bool expand)
    {
        return css.expand(expand, expand);
    }

    //alignment:
    public static css align(TextAnchor alignment)
    {
        return new css(x => x.alignment = alignment);
    }

    //upper middle lower
    //left center right
    public static css align_left()
    {
        return new css(x =>
        {
            //calc algh:
            // 0  1  2  3  4  5  6  7  8 | *(-1)
            // 0 -1 -2 -3 -4 -5 -6 -7 -8 | % 3
            // 0 -1 -2  0 -1 -2  0 -1 -2
            var offset = -(int)x.alignment % 3;
            var value = (TextAnchor)((int)x.alignment + offset);
            x.alignment = value;
      });
    }

    public static css align_right()
    {
        return new css(x =>
        {
            //calc algh:
            // 0  1  2  3  4  5  6  7  8 | *(-1)
            // 0 -1 -2 -3 -4 -5 -6 -7 -8 | % 3
            // 0 -1 -2  0 -1 -2  0 -1 -2 | + 2
            // 2  1  0  2  1  0  2  1  0 
            var offset = -(int)x.alignment % 3 + 2;
            var value = (TextAnchor)((int)x.alignment + offset);
            x.alignment = value;
        });
    }

    public static css align_center_x()
    {
        return new css(x =>
        {
            //calc algh:
            // 0  1  2  3  4  5  6  7  8 | *(-1)
            // 0 -1 -2 -3 -4 -5 -6 -7 -8 | / 3
            // 0  0  0 -1 -1 -1 -2 -2 -2 | + 1
            // 1  1  1  0  0  0 -1 -1 -1 | * 3
            // 3  3  3  0  0  0 -3 -3 -3
            var offset = -(int)x.alignment / 3 + 1;
            var value = (TextAnchor)((int)x.alignment + offset*3);
            x.alignment = value;
        });
    }

    public static css align_center_y()
    {
        return new css(x =>
        {
            //calc algh:
            // 0  1  2  3  4  5  6  7  8 | *(-1)
            // 0 -1 -2 -3 -4 -5 -6 -7 -8 | % 3
            // 0 -1 -2  0 -1 -2  0 -1 -2 | + 2
            // 1  0 -1  1  0 -1  1  0 -1
            var offset = -(int)x.alignment % 3 + 1;
            var value = (TextAnchor)((int)x.alignment + offset);
            x.alignment = value;

        });
    }

    public static css align_top()
    {
        return new css(x =>
        {
            //calc algh:
            //| 0  1  2|     | 0 -1 -2|   | 0  0  0|   | 0  0  0|
            //| 3  4  5|*(-1)|-3 -4 -5|/ 3|-1 -1 -1|* 3|-3 -3 -3|
            //| 6  7  8|     |-6 -7 -8|   |-2 -2 -2|   |-6 -6 -6|
            var offset = -(int)x.alignment / 3 * 3;
            var value = (TextAnchor)((int)x.alignment + offset);
            x.alignment = value;
            
        });
    }

    public static css align_bottom()
    {
        return new css(x =>
        {
            //calc algh:
            // 0  1  2  3  4  5  6  7  8 | *(-1)
            // 0 -1 -2 -3 -4 -5 -6 -7 -8 | / 3
            // 0  0  0 -1 -1 -1 -2 -2 -2 | + 2
            // 2  2  2  1  1  1  0  0  0 | * 3
            // 6  6  6  3  3  3  0  0  0
            var offset = -(int)x.alignment / 3 + 2;
            var value = (TextAnchor)((int)x.alignment + offset*3);
            x.alignment = value;
        });
    }

    //color:
    public static css color(Color color)
    {
        return new css(style =>
        {
            style.normal.textColor = color;
            style.focused.textColor = color;
            style.hover.textColor = color;
            style.active.textColor = color;
            style.onNormal.textColor = color;
            style.onFocused.textColor = color;
            style.onHover.textColor = color;
            style.onActive.textColor = color;
        });
    }

    public static css color_normal(Color color)
    {
        return new css(x => x.normal.textColor = color);
    }

    public static css color_hover(Color color)
    {
        return new css(x => x.hover.textColor = color);
    }

    public static css color_focused(Color color)
    {
        return new css(x => x.focused.textColor = color);
    }

    public static css color_active(Color color)
    {
        return new css(x => x.active.textColor = color);
    }

    public static css color_onNormal(Color color)
    {
        return new css(x => x.onNormal.textColor = color);
    }

    public static css color_onHover(Color color)
    {
        return new css(x => x.onHover.textColor = color);
    }

    public static css color_onFocused(Color color)
    {
        return new css(x => x.onFocused.textColor = color);
    }

    public static css color_onActive(Color color)
    {
        return new css(x => x.onActive.textColor = color);
    }

    //font-size
    public static css font_size(int fontSize)
    {
        return new css(x => x.fontSize = fontSize);
    }

    //rich-text
    public static css rich(bool richText)
    {
        return new css(x => x.richText = richText);
    }

    //style
    public static css font_style(FontStyle style)
    {
        return new css(x => x.fontStyle = style);
    }

    //normal, bold, italic, boldItalic
    public static css bold()
    {
        return bold(true);
    }

    private static int[] stylesBoldOffset = {1, 0, 1, 0};
    public static css bold(bool boldStatus)
    {
        if (boldStatus)
            return new css(x => x.fontStyle = (FontStyle) ((int) x.fontStyle + stylesBoldOffset[(int) x.fontStyle]));
        return new css(x => x.fontStyle = (FontStyle) ((int) x.fontStyle - stylesBoldOffset[3 - (int) x.fontStyle]));
    }

    private static int[] styleItalicOffset = {2, 2, 0, 0};
    public static css italic(bool italicStatus)
    {
        if (italicStatus)
            return new css(x => x.fontStyle = (FontStyle)((int)x.fontStyle + styleItalicOffset[(int)x.fontStyle]));
        return new css(x => x.fontStyle = (FontStyle)((int)x.fontStyle - styleItalicOffset[3 - (int)x.fontStyle]));
    }

    public static css hidden(int width)
    {
        return new css(str =>
        {
            if (str.Length > width)
                str = str.Substring(0, width - 3) + "...";
            return str;
        });
    }

    //space:
    public static css space(int top_right_bottom_left)
    {
        return new css
        {
            actionBeforeElement = () =>
            {
                gui.begin_vertical(expand(false));
                gui.space(top_right_bottom_left);
                gui.begin_horizontal(expand(false));
                gui.space(top_right_bottom_left);
            },
            actionAfterElement = () =>
            {
                gui.space(top_right_bottom_left);
                gui.end();
                gui.space(top_right_bottom_left);
                gui.end();
            }
        };
    }

    public static css space(int top_bottom, int left_right)
    {
        return new css
        {
            actionBeforeElement = () =>
            {
                gui.begin_vertical(expand(false));
                gui.space(top_bottom);
                gui.begin_horizontal(expand(false));
                gui.space(left_right);
            },
            actionAfterElement = () =>
            {
                gui.space(left_right);
                gui.end();
                gui.space(top_bottom);
                gui.end();
            }
        };
    }

    public static css space(int top, int left_right, int bottom)
    {
        return new css
        {
            actionBeforeElement = () =>
            {
                gui.begin_vertical(expand(false));
                gui.space(top);
                gui.begin_horizontal(expand(false));
                gui.space(left_right);
            },
            actionAfterElement = () =>
            {
                gui.space(left_right);
                gui.end();
                gui.space(bottom);
                gui.end();
            }
        };
    }

    public static css space(int top, int right, int bottom, int left)
    {
        return new css
        {
            actionBeforeElement = () =>
            {
                gui.begin_vertical(expand(false));
                gui.space(top);
                gui.begin_horizontal(expand(false));
                gui.space(left);
            },
            actionAfterElement = () =>
            {
                gui.space(right);
                gui.end();
                gui.space(bottom);
                gui.end();
            }
        };
    }

    public static css space_left(int left)
    {
        return new css
        {
            actionBeforeElement = () =>
            {
                gui.begin_horizontal(expand(false));
                gui.space(left);
            },
            actionAfterElement = () =>
            {
                gui.end();
            }
        };
    }

    public static css space_right(int right)
    {
        return new css
        {
            actionBeforeElement = () =>
            {
                gui.begin_horizontal(expand(false));
            },
            actionAfterElement = () =>
            {
                gui.space(right);
                gui.end();
            }
        };
    }

    public static css space_top(int top)
    {
        return new css
        {
            actionBeforeElement = () =>
            {
                gui.begin_vertical(expand(false));
                gui.space(top);
            },
            actionAfterElement = () =>
            {
                gui.end();
            }
        };
    }

    public static css space_bottom(int bottom)
    {
        return new css
        {
            actionBeforeElement = () =>
            {
                gui.begin_vertical(expand(false));
            },
            actionAfterElement = () =>
            {
                gui.space(bottom);
                gui.end();
            }
        };
    }

    public static css space_horizontal(int leftRight)
    {
        return new css
        {
            actionBeforeElement = () =>
            {
                gui.begin_horizontal(expand(false));
                gui.space(leftRight);
            },
            actionAfterElement = () =>
            {
                gui.space(leftRight);
                gui.end();
            }
        };
    }

    public static css space_vertical(int topBottom)
    {
        return new css
        {
            actionBeforeElement = () =>
            {
                gui.begin_vertical(expand(false));
                gui.space(topBottom);
            },
            actionAfterElement = () =>
            {
                gui.space(topBottom);
                gui.end();
            }
        };
    }

    public static css space_horizontal(int left, int right)
    {
        return new css
        {
            actionBeforeElement = () =>
            {
                gui.begin_horizontal(expand(false));
                gui.space(left);
            },
            actionAfterElement = () =>
            {
                gui.space(right);
                gui.end();
            }
        };
    }

    public static css space_vertical(int top, int bottom)
    {
        return new css
        {
            actionBeforeElement = () =>
            {
                gui.begin_vertical(expand(false));
                gui.space(top);
            },
            actionAfterElement = () =>
            {
                gui.space(bottom);
                gui.end();
            }
        };
    }

    //
    public static css word_wrap(bool wordWrap)
    {
        return new css(x => x.wordWrap = wordWrap);
    }

    //matrix
    public static css render_scale(float xScale, float yScale)
    {
        return new css
        {
            actionBeforeElement = () => gui.begin_matrix(Matrix4x4.Scale(new Vector3(xScale,yScale,1))),
            actionAfterElement = () => gui.end(),
        };
    }

    public static css render_scale(float scale)
    {
        return new css
        {
            actionBeforeElement = () => gui.begin_matrix(Matrix4x4.Scale(new Vector3(scale, scale, 1))),
            actionAfterElement = () => gui.end(),
        };
    }

    public static css render_scale(float xScale, float yScale, Vector2 point)
    {
        var matrixOld = GUI.matrix;
        return new css
        {
            actionBeforeElement = () => GUIUtility.ScaleAroundPivot(new Vector2(xScale, yScale), point),
            actionAfterElement = () => GUI.matrix = matrixOld,
        };
    }

    public static css render_scale(float scale, Vector2 point)
    {
        var matrixOld = GUI.matrix;
        return new css
        {
            actionBeforeElement = () => GUIUtility.ScaleAroundPivot(new Vector2(scale, scale), point),
            actionAfterElement = () => GUI.matrix = matrixOld,
        };
    }

    public static css render_inverse()
    {
        return new css
        {
            actionBeforeElement = () => gui.begin_matrix(Matrix4x4.Inverse(GUI.matrix)),
            actionAfterElement = () => gui.end(),
        };
    }

    public static css render_rotate(float angle, Vector2 point)
    {
        return new css
        {
            actionBeforeElement = () => GUIUtility.RotateAroundPivot(angle, point),
            actionAfterElement = () => GUIUtility.RotateAroundPivot(-angle, point),
        };
    }
    
    //enabled
    public static css enabled(bool enable)
    {
        return new css
        {
            actionBeforeElement = () => gui.begin_enabled(enable),
            actionAfterElement = () => gui.end(),
        };
    }

    //set state guistyle
    public static css style_state(Func<GUIStyle, GUIStyleState> stateFunc)
    {
        return new css(x => x.normal = stateFunc(x));
    }

    //font
    public static css font_family(Font font)
    {
        return new css(x => x.font = font);
    }

    //controlName
    public static css control_name(string controlName)
    {
        return new css { actionBeforeElement = () => GUI.SetNextControlName(controlName) };
    }

    public static css style_action(Action<GUIStyle> styleAction)
    {
        return new css(styleAction);
    }

    public static css label(string fieldname)
    {
        return new css
        {
            actionBeforeElement = () =>
            {
                gui.begin_horizontal();
                gui.label(fieldname + ":");
            },
            actionAfterElement = () => gui.end()
        };
    }

    public static css pack(params css[] options)
    {
        return new css {options = options};
    }

    public static css style(GUIStyle style)
    {
        return new css().AddAdvanced("style", style);
    }

    public delegate void VoidDelegate();
    public static VoidDelegate loadCssPacksDelegate;

    private static Dictionary<string, css> cssPacks;

    public static css pack(string key, bool ignoreError = false)
    {
        if (cssPacks == null && loadCssPacksDelegate != null)
            loadCssPacksDelegate();
        if (cssPacks != null && cssPacks.ContainsKey(key))
            return cssPacks[key];
        if (!ignoreError)
            throw new Exception("Не найден пак свойств с названием '" + key + "'");
        return null;
        
    }

    public static IDisposable RegisterPack(string key, bool isParent, params css[] options)
    {
        if (cssPacks == null)
            cssPacks = new Dictionary<string, css>();
        if (parentsPack.Count > 0)
        {
            var l = options.ToList();
            l.Insert(0, pack(parentsPack[parentsPack.Count - 1]));
            options = l.ToArray();
        }
        cssPacks.Add(key, pack(options));
        if (isParent)
            return new RegisterPackDisposable(key);
        return null;
    }

    private static List<string> parentsPack = new List<string>();

    private class RegisterPackDisposable : IDisposable
    {
        public RegisterPackDisposable(string key)
        {
            parentsPack.Add(key);
        }

        ~RegisterPackDisposable()
        {
            Dispose();
        }

        public void Dispose()
        {
            parentsPack.RemoveAt(parentsPack.Count - 1);
        }
    }

    public static css vertical_centrize()
    {
        return new css
        {
            actionBeforeElement = () =>
            {
                gui.begin_vertical(expand_width(true, false));
                gui.space();
            },
            actionAfterElement = () =>
            {
                gui.space();
                gui.end();
            }
        };
    }

    public static css color_background(Color color)
    {
        var backColor = GUI.backgroundColor;
        return new css
        {
            actionBeforeElement = () => GUI.backgroundColor = color,
            actionAfterElement = () => GUI.backgroundColor = backColor
        };
    }

    public static css color_background_alpha(float alpha)
    {
        var backColor = GUI.backgroundColor;
        return new css
        {
            actionBeforeElement = () => GUI.backgroundColor = new Color(backColor.r, backColor.g, backColor.b, alpha),
            actionAfterElement = () => GUI.backgroundColor = backColor
        };
    }
}