﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using UnityEditor;
using UnityEngine;

public static partial class gui
{
    public static bool enabled { get { return GUI.enabled; } set { GUI.enabled = value; }}

    private static GUIStyle _getStyle(GUIStyle style, css[] options)
    {
//        return style;
        if (options == null)
            return style;
        
        style = new GUIStyle(style);
//        for (int i = 0; i < options.Length; i++)
//        {
//            
//        }

        for (int i = 0; i < options.Length; i++)
        {
            var s = options[i].GetAdvanced("style");
            if (s != null)
                style = new GUIStyle(s as GUIStyle);
            if (options[i].options != null)
                style = _getStyle(style, options[i].options);
            if (options[i].styleChanged != null)
                options[i].styleChanged(style);
        }
        return style;
    }


    private static GUILayoutOption[] _getOptions(css[] options)
    {
//        return null;
        if (options == null)
            return null;

        var list = new List<GUILayoutOption>();
        for (int i = 0; i < options.Length; i++)
        {
            if (options[i].option != null)
                list.AddRange(options[i].option);
            if (options[i].options != null)
                list.AddRange(_getOptions(options[i].options));
        }
        return list.ToArray();
    }

    private static GUIContent[] _getContent(GUIContent[] contents, css[] options)
    {
//        return contents;
        if (options == null || contents == null)
            return null;

        var modifs = new List<Func<string, string>>();
        for (int i = 0; i < options.Length; i++)
            if (options[i].contentString != null)
                modifs.Add(options[i].contentString);

        if (modifs.Count == 0)
            return contents;

        var result = new GUIContent[contents.Length];
        for (int i = 0; i < contents.Length; i++)
        {
            result[i] = new GUIContent(contents[i]);
            for (int j = 0; j < modifs.Count; j++)
                result[i].text = modifs[j](result[i].text);
        }
        return result;
    }

    private static GUIContent _getContent(GUIContent content, css[] options)
    {
//        return content;
        if (options == null && content.text == null)
            return content;

        content = new GUIContent(content);
        content.text = _getContent(content.text, options);
        return content;
    }

    private static string _getContent(string str, css[] options)
    {
//        return str;
        if (options == null || str == null)
            return str;

        for (int i = 0; i < options.Length; i++)
            if (options[i].contentString != null)
                str = options[i].contentString(str);
        return str;
    }

    private static void _actionsBefore(css[] options)
    {
        if (options == null)
            return;
//        return;
        for (int i = options.Length - 1; i >= 0; i--)
        {
            if (options[i].options != null)
                _actionsBefore(options[i].options);
            if (options[i].actionBeforeElement != null)
                options[i].actionBeforeElement();
        }
    }

    private static void _actionsAfter(css[] options)
    {
        if (options == null)
            return;

        for (int i = 0; i < options.Length; i++)
        {
            if (options[i].actionAfterElement != null)
                options[i].actionAfterElement();
            if (options[i].options != null)
                _actionsAfter(options[i].options);
        }
    }

    //button:
    public static bool button(GUIContent content, GUIStyle style, params css[] options)
    {
        _actionsBefore(options);
        var result = GUILayout.Button(_getContent(content, options), _getStyle(style, options), _getOptions(options));
        _actionsAfter(options);
        return result;
    }

    public static bool button(GUIContent content, params css[] options)
    {
        return button(content, GUI.skin.button, options);
    }

    public static bool button(GUIContent content, string packOrStyle, params css[] options)
    {
        return button(content, GUI.skin.button, _mergeOptions(packOrStyle, options));
    }

//    public static bool button(GUIContent content, string packname, params css[] options)
//    {
//        mergeOptions(packname, ref options);
//        return button(content, GUI.skin.button, options);
//    }

    public static bool button(Texture2D tex, GUIStyle style, params css[] options)
    {
        return button(new GUIContent(tex), style, options);
    }

    public static bool button(Texture2D tex, params css[] options)
    {
        return button(new GUIContent(tex), options);
    }

//    public static bool button(Texture2D tex, string packname, params css[] options)
//    {
//        mergeOptions(packname, ref options);
//        return button(new GUIContent(tex), options);
//    }

    public static bool button(string title, GUIStyle style, params css[] options)
    {
        return button(new GUIContent(title), style, options);
    }

    public static bool button(string title, params css[] options)
    {
        return button(new GUIContent(title), options);
    }
    //r
    public static bool button(Rect rect, GUIContent content, GUIStyle style, params css[] options)
    {
        _actionsBefore(options);
        var result = GUI.Button(rect, _getContent(content, options), _getStyle(style, options));
        _actionsAfter(options);
        return result;
    }

    public static bool button(Rect rect, GUIContent content, params css[] options)
    {
        return button(rect, content, GUI.skin.button, options);
    }

    public static bool button(Rect rect, GUIContent content, string packOrStyle, params css[] options)
    {
        return button(rect, content, GUI.skin.button, _mergeOptions(packOrStyle, options));
    }

    //    public static bool button(GUIContent content, string packname, params css[] options)
    //    {
    //        mergeOptions(packname, ref options);
    //        return button(content, GUI.skin.button, options);
    //    }

    public static bool button(Rect rect, Texture2D tex, GUIStyle style, params css[] options)
    {
        return button(rect, new GUIContent(tex), style, options);
    }

    public static bool button(Rect rect, Texture2D tex, params css[] options)
    {
        return button(rect, new GUIContent(tex), options);
    }

    //    public static bool button(Texture2D tex, string packname, params css[] options)
    //    {
    //        mergeOptions(packname, ref options);
    //        return button(new GUIContent(tex), options);
    //    }

    public static bool button(Rect rect, string title, GUIStyle style, params css[] options)
    {
        return button(rect, new GUIContent(title), style, options);
    }

    public static bool button(Rect rect, string title, params css[] options)
    {
        return button(rect, new GUIContent(title), options);
    }

//    public static bool button(string title, string packname, params css[] options)
//    {
//        mergeOptions(packname, ref options);
//        return button(new GUIContent(title), options);
//    }

    //box:
    public static void box(GUIStyle style, params css[] options)
    {
        _actionsBefore(options);
        GUILayout.Box(new GUIContent(), _getStyle(style, options), _getOptions(options));
        _actionsAfter(options);
    }

    public static void box(params css[] options)
    {
        box(GUI.skin.box, options);
    }

    public static void box(Texture2D tex, GUIStyle style, params css[] options)
    {
        _actionsBefore(options);
        GUILayout.Box(new GUIContent(tex), _getStyle(style, options), _getOptions(options));
        _actionsAfter(options);
    }

    public static void box(Texture2D tex, params css[] options)
    {
        box(tex, GUI.skin.box, options);
    }

    public static void box(Rect rect, string packOrStyle, params css[] options)
    {
        options = _mergeOptions(packOrStyle, options);
        _actionsBefore(options);
        GUI.Box(rect, new GUIContent(), _getStyle(GUIStyle.none, options));
        _actionsAfter(options);
    }

    public static void box(Rect rect, GUIStyle style, params css[] options)
    {
        _actionsBefore(options);
        GUI.Box(rect, new GUIContent(), _getStyle(style, options));
        _actionsAfter(options);
    }

    public static void box(Rect rect, params css[] options)
    {
        box(rect, GUI.skin.box, options);
    }

    public static void box(Rect rect, Texture2D tex, GUIStyle style, params css[] options)
    {
        _actionsBefore(options);
        GUI.Box(rect, new GUIContent(tex), _getStyle(style, options));
        _actionsAfter(options);
    }

    public static void box(Rect rect, Texture2D tex, params css[] options)
    {
        box(rect, tex, GUI.skin.box, options);
    }

    //minibutton:
    private const string minibuttonDefaultStyle = "minibutton";
    public static bool minibutton(GUIContent content, params css[] options)
    {
        _actionsBefore(options);
        var result = GUILayout.Button(_getContent(content, options), _getStyle(minibuttonDefaultStyle, options), _getOptions(options));
        _actionsAfter(options);
        return result;
    }

    public static bool minibutton(Texture2D tex, params css[] options)
    {
        return minibutton(new GUIContent(tex), options);
    }

    public static bool minibutton(string title, params css[] options)
    {
        return minibutton(new GUIContent(title), options);
    }

    //toggle
    public static bool toggle(bool value, GUIContent content, GUIStyle style, params css[] options)
    {
        _actionsBefore(options);
        var result = GUILayout.Toggle(value, _getContent(content, options), _getStyle(style, options), _getOptions(options));
        _actionsAfter(options);
        return result;
    }

    public static bool toggle(bool value, string title, GUIStyle style, params css[] options)
    {
        return toggle(value, new GUIContent(title), style, options);
    }

    public static bool toggle(bool value, Texture2D tex, GUIStyle style, params css[] options)
    {
        return toggle(value, new GUIContent(tex), style, options);
    }

    public static bool toggle(bool value, GUIContent content, params css[] options)
    {
        return toggle(value, content, GUI.skin.toggle);
    }

    public static bool toggle(bool value, string title, params css[] options)
    {
        return toggle(value, title, GUI.skin.toggle);
    }

    public static bool toggle(bool value, Texture2D texture, params css[] options)
    {
        return toggle(value, texture, GUI.skin.toggle);
    }

    public static bool toggle(ref bool value, GUIContent title, GUIStyle style, params css[] options)
    {
        var result = toggle(value, new GUIContent(title), style, options);
        if (result == value)
            return false;
        value = result;
        return true;
    }

    public static bool toggle(ref bool value, string title, GUIStyle style, params css[] options)
    {
        var result = toggle(value, new GUIContent(title), style, options);
        if (result == value)
            return false;
        value = result;
        return true;
    }

    public static bool toggle(ref bool value, Texture2D tex, GUIStyle style, params css[] options)
    {
        var result = toggle(value, new GUIContent(tex), style, options);
        if (result == value)
            return false;
        value = result;
        return true;
    }

    public static bool toggle(ref bool value, GUIContent content, params css[] options)
    {
        var result = toggle(value, content, GUI.skin.toggle, options);
        if (result == value)
            return false;
        value = result;
        return true;
    }

    public static bool toggle(ref bool value, string title, params css[] options)
    {
        var result = toggle(value, title, GUI.skin.toggle, options);
        if (result == value)
            return false;
        value = result;
        return true;
    }

    public static bool toggle(ref bool value, Texture2D texture, params css[] options)
    {
        var result = toggle(value, texture, GUI.skin.toggle, options);
        if (result == value)
            return false;
        value = result;
        return true;
    }

    //label:
    private const string labelDefaultStyle = "label";
    public static void label(GUIContent content, GUIStyle style, params css[] options)
    {
        _actionsBefore(options);
        GUILayout.Label(_getContent(content, options), _getStyle(style, options), _getOptions(options));
        _actionsAfter(options);
    }

    public static void label(GUIContent content, params css[] options)
    {
         label(content, labelDefaultStyle, options);
    }

    public static void label(Texture2D tex, GUIStyle style, params css[] options)
    {
         label(new GUIContent(tex), style, options);
    }

    public static void label(Texture2D tex, params css[] options)
    {
         label(new GUIContent(tex), options);
    }

    public static void label(string text, GUIStyle style, params css[] options)
    {
        label(new GUIContent(text), style, options);
    }

    public static void label(object text, GUIStyle style, params css[] options)
    {
        label(new GUIContent(text.ToString()), style, options);
    }

    public static void label(string text, params css[] options)
    {
        label(new GUIContent(text), options);
    }

    public static void label(object text, params css[] options)
    {
        label(new GUIContent(text.ToString()), options);
    }

    //labelrect
    public static void label(Rect rect, GUIContent content, GUIStyle style, params css[] options)
    {
        _actionsBefore(options);
        GUI.Label(rect, _getContent(content, options), _getStyle(style, options));
        _actionsAfter(options);
    }

    public static void label(Rect rect, GUIContent content, params css[] options)
    {
        label(rect, content, labelDefaultStyle, options);
    }

    public static void label(Rect rect, Texture2D tex, GUIStyle style, params css[] options)
    {
        label(rect, new GUIContent(tex), style, options);
    }

    public static void label(Rect rect, Texture2D tex, params css[] options)
    {
        label(rect, new GUIContent(tex), options);
    }

    public static void label(Rect rect, string text, GUIStyle style, params css[] options)
    {
        label(rect, new GUIContent(text), style, options);
    }

    public static void label(Rect rect, object text, GUIStyle style, params css[] options)
    {
        label(rect, new GUIContent(text.ToString()), style, options);
    }

    public static void label(Rect rect, string text, params css[] options)
    {
        label(rect, new GUIContent(text), options);
    }

    public static void label(Rect rect, object text, params css[] options)
    {
        label(rect, new GUIContent(text.ToString()), options);
    }

    //textarea
    public static string textarea(string text, GUIStyle style, params css[] options)
    {
        _actionsBefore(options);
        var result = GUILayout.TextArea(_getContent(text ?? "", options), _getStyle(style, options), _getOptions(options));
        _actionsAfter(options);
        return result;
    }

    public static string textarea(string text, params css[] options)
    {
        return textarea(text, GUI.skin.textArea, options);
    }

    public static string textarea(Rect r, string text, params css[] options)
    {
        _actionsBefore(options);
        var result = GUI.TextArea(r, _getContent(text ?? "", options), _getStyle(GUI.skin.textArea, options));
        _actionsAfter(options);
        return result;
    }

    public static string textarea(string text, int maxLength, GUIStyle style, params css[] options)
    {
        _actionsBefore(options);
        var result = GUILayout.TextArea(_getContent(text ?? "", options), maxLength, _getStyle(style, options), _getOptions(options));
        _actionsAfter(options);
        return result;
    }

    public static string textarea(string text, int maxLength, params css[] options)
    {
        return textarea(text, maxLength, GUI.skin.textArea, options);
    }

    public static bool textarea(ref string text, GUIStyle style, params css[] options)
    {
        var resultText = textarea(text, style, options);
        if (text == resultText)
            return false;
        text = resultText;
        return true;
    }

    public static bool textarea(ref string text, params css[] options)
    {
        return textarea(ref text, GUI.skin.textArea, options);
    }

    public static bool textarea(ref string text, int maxLength, GUIStyle style, params css[] options)
    {
        var resultText = textarea(text, maxLength, style, options);
        if (text == resultText)
            return false;
        text = resultText; 
        return true;
    }

    public static bool textarea(ref string text, int maxLength, params css[] options)
    {
        return textarea(ref text, maxLength, GUI.skin.textArea, options);
    }

    //textfield
    public static string textfield(string text, GUIStyle style, params css[] options)
    {
        _actionsBefore(options);
        var result = GUILayout.TextField(_getContent(text ?? "", options), _getStyle(style, options), _getOptions(options));
        _actionsAfter(options);
        return result;
    }

    public static string textfield(string text, params css[] options)
    {
        return textfield(text, GUI.skin.textField, options);
    }

    public static string textfield(string text, int maxLength, GUIStyle style, params css[] options)
    {
        _actionsBefore(options);
        var result = GUILayout.TextField(_getContent(text ?? "", options), maxLength, _getStyle(style, options), _getOptions(options));
        _actionsAfter(options);
        return result;
    }

    public static string textfield(string text, int maxLength, params css[] options)
    {
        return textfield(text, maxLength, GUI.skin.textField, options);
    }

    public static bool textfield(ref string text, GUIStyle style, params css[] options)
    {
        var resultText = textfield(text, style, options);
        if (text == resultText)
            return false;
        text = resultText;
        return true;
    }

    public static bool textfield(ref string text, params css[] options)
    {
        return textfield(ref text, GUI.skin.textField, options);
    }

    public static bool textfield(ref string text, int maxLength, GUIStyle style, params css[] options)
    {
        var resultText = textfield(text, maxLength, style, options);
        if (text == resultText)
            return false;
        text = resultText;
        return true;
    }

    public static bool textfield(ref string text, int maxLength, params css[] options)
    {
        return textfield(ref text, maxLength, GUI.skin.textField, options);
    }

    //
    public static void space(int space)
    {
        GUILayout.Space(space);
    }

    public static void space()
    {
        GUILayout.FlexibleSpace();
    }

    private static List<Action> endActions = new List<Action>();
    public static void begin_horizontal(GUIStyle style, params css[] options)
    {
        _actionsBefore(options);
        GUILayout.BeginHorizontal(_getStyle(style, options), _getOptions(options));
        endActions.Add(() =>
        {
            GUILayout.EndHorizontal();
            _actionsAfter(options);
        });
    }

    public static void begin_horizontal(params css[] options)
    {
        begin_horizontal(GUIStyle.none, options);
    }

    public static void begin_vertical(GUIStyle style, params css[] options)
    {
        _actionsBefore(options);
        GUILayout.BeginVertical(_getStyle(style, options), _getOptions(options));
        endActions.Add(() =>
        {
            GUILayout.EndVertical();
            _actionsAfter(options);
        });
    }

    public static void begin_vertical(params css[] options)
    {
        begin_vertical(GUIStyle.none, options);
    }

    public static void begin_horizontal(ref Vector2 scroll, GUIStyle style, params css[] options)
    {
        _actionsBefore(options);
        GUILayout.BeginHorizontal(_getStyle(style, options), _getOptions(options));
        scroll = GUILayout.BeginScrollView(scroll);
        endActions.Add(() =>
        {
            GUILayout.EndScrollView();
            GUILayout.EndHorizontal();
            _actionsAfter(options);
        }
    );
    }

    public static void begin_horizontal(ref Vector2 scroll, params css[] options)
    {
        begin_horizontal(ref scroll, GUIStyle.none, options);
    }

    public static void begin_vertical(ref Vector2 scroll, GUIStyle style, params css[] options)
    {
        _actionsBefore(options);
        GUILayout.BeginVertical(_getStyle(style, options), _getOptions(options));
        scroll = GUILayout.BeginScrollView(scroll);
        endActions.Add(() =>
        {
            GUILayout.EndScrollView();
            GUILayout.EndVertical();
            _actionsAfter(options);
        });
    }

    public static void begin_vertical(ref Vector2 scroll, params css[] options)
    {
        begin_vertical(ref scroll, GUIStyle.none, options);
    }
    
    public static void begin_scroll(ref Vector2 scrollPos, params css[] options)
    {
        _actionsBefore(options);
        scrollPos = GUILayout.BeginScrollView(scrollPos, _getOptions(options));
        endActions.Add(() =>
        {
            GUILayout.EndScrollView();
            _actionsAfter(options);
        });
    }

    public static void begin_scroll(ref Vector2 scrollPos, string packOrStyle, params css[] options)
    {
        options = _mergeOptions(packOrStyle, options);
        _actionsBefore(options);
        scrollPos = GUILayout.BeginScrollView(scrollPos, false, false, GUI.skin.horizontalScrollbar, GUI.skin.verticalScrollbar, _getStyle(GUI.skin.scrollView, options), _getOptions(options));
        endActions.Add(() =>
        {
            GUILayout.EndScrollView();
            _actionsAfter(options);
        });
    }

    public static IDisposable group_scroll(ref Vector2 scrollPos, string packOrStyle, params css[] options)
    {
        begin_scroll(ref scrollPos, packOrStyle, options);
        return new _Group();
    }

    public static IDisposable group_scroll(ref Vector2 scrollPos, params css[] options)
    {
        begin_scroll(ref scrollPos, options);
        return new _Group();
    }

    public static void end()
    {
        var endElement = endActions[endActions.Count - 1];
        endActions.RemoveAt(endActions.Count - 1);
        endElement.Invoke();
    }

    public static IDisposable group_horizontal(params css[] options)
    {
        begin_horizontal(options);
        return new _Group();
    }

    public static IDisposable group_horizontal(string packOrStyle, params css[] options)
    {
        begin_horizontal(_mergeOptions(packOrStyle, options));
        return new _Group();
    }


    public static IDisposable group_horizontal(GUIStyle style, params css[] options)
    {
        begin_horizontal(style, options);
        return new _Group();
    }

//    public static IDisposable group_horizontal(string packname, params css[] options)
//    {
//        mergeOptions(packname, ref options);
//        begin_horizontal(options);
//        return new _Group();
//    }

    public static IDisposable group_vertical(params css[] options)
    {
        begin_vertical(options);
        return new _Group();
    }

    public static IDisposable group_vertical(string packOrStyle, params css[] options)
    {
        begin_vertical(_mergeOptions(packOrStyle, options));
        return new _Group();
    }

    public static IDisposable group_vertical(GUIStyle style, params css[] options)
    {
        begin_vertical(style, options);
        return new _Group();
    }

    public static IDisposable group_horizontal(ref Vector2 scroll, params css[] options)
    {
        begin_horizontal(ref scroll, options);
        return new _Group();
    }

    public static IDisposable group_horizontal(ref Vector2 scroll, GUIStyle style, params css[] options)
    {
        begin_horizontal(ref scroll, style, options);
        return new _Group();
    }

    public static IDisposable group_vertical(ref Vector2 scroll, params css[] options)
    {
        begin_vertical(ref scroll, options);
        return new _Group();
    }

    public static IDisposable group_vertical(ref Vector2 scroll, GUIStyle style, params css[] options)
    {
        begin_vertical(ref scroll, style, options);
        return new _Group();
    }

    private class _Group : IDisposable
    {
        public void Dispose()
        {
            end();
        }
    }

    public static void begin_enabled(bool enabled)
    {
        var enabledOld = gui.enabled;
        gui.enabled = enabled;
        endActions.Add(() => { gui.enabled = enabledOld; });
    }

    public static IDisposable group_enabled(bool enabled)
    {
        begin_enabled(enabled);
        return new _Group();
    }

    public static _ControlInfo render(GUIContent content, GUIStyle style, bool mayBeFocus, params css[] options)
    {
        _actionsBefore(options);
        style = _getStyle(style, options);
        content = _getContent(content, options);
        var ops = _getOptions(options);
        var result = new _ControlInfo
        {
            rect = GUILayoutUtility.GetRect(content, style, ops),
            mayBeKeyboardFocus = mayBeFocus
        };
        result.id = GUIUtility.GetControlID("render_xgmguru".GetHashCode(), mayBeFocus ? FocusType.Keyboard : FocusType.Passive, result.rect);
        if (Event.current.type == EventType.Repaint)
            style.Draw(result.rect, content, result.id);
        _actionsAfter(options);
        return result;
    }

    public static _ControlInfo render(GUIContent content, string packOrStyle, params css[] options)
    {
        options = _mergeOptions(packOrStyle, options);
        return render(content, GUIStyle.none, false, options);
    }

    public static _ControlInfo render(string content, string packOrStyle, params css[] options)
    {
        options = _mergeOptions(packOrStyle, options);
        return render(new GUIContent(content), GUIStyle.none, false, options);
    }

    public static _ControlInfo render(Texture2D content, string packOrStyle, params css[] options)
    {
        options = _mergeOptions(packOrStyle, options);
        return render(new GUIContent(content), GUIStyle.none, false, options);
    }

    public static _ControlInfo render(string text, GUIStyle style, bool mayBeFocus, params css[] options)
    {
        return render(new GUIContent(text), style, mayBeFocus, options);
    }

    public static _ControlInfo render(Texture2D tex, GUIStyle style, bool mayBeFocus, params css[] options)
    {
        return render(new GUIContent(tex), style, mayBeFocus, options);
    }

    public static void begin_matrix(Matrix4x4 matrix)
    {
        var oldMatrix = GUI.matrix;
        GUI.matrix = matrix;
        endActions.Add(() => { GUI.matrix = oldMatrix; });
    }

    public static IDisposable group_matrix(Matrix4x4 matrix)
    {
        begin_matrix(matrix);
        return new _Group();
    }

    public static void control_focus(string controlName)
    {
        GUI.FocusControl(controlName);
    }

    public static int popup(Vector2 position, bool show, int index, string[] variants)
    {
        var control = new _ControlInfo
        {
            rect = new Rect(position.x, position.y, 0, 0),
            mayBeKeyboardFocus = false,
        };
        control.id = GUIUtility.GetControlID("render_xgmguru_popup".GetHashCode(), FocusType.Passive, control.rect);
        if (show)
            control.CustomMenuDisplay(index, variants);
        control.CustomMenuApply(ref index);
        return index;
    }

    public static int popup(GUIContent content, int index, string[] variants, GUIStyle style, params css[] options)
    {
        var control = render(content, style, false, options);
        if (GUI.Button(control.rect, _getContent(content, options), _getStyle(style, options)))
            control.CustomMenuDisplay(index, variants);
        control.CustomMenuApply(ref index);
        return index;
    }

    public static int popup(GUIContent content, int index, Func<string[]> variants, GUIStyle style, params css[] options)
    {
        var control = render(content, style, false, options);
        if (GUI.Button(control.rect, _getContent(content, options), _getStyle(style, options)))
            control.CustomMenuDisplay(index, variants());
        control.CustomMenuApply(ref index);
        return index;
    }

    public static int popup<T>(GUIContent content, int index, Func<IList<T>> variants, Func<T, string> strs, Action<T> action, GUIStyle style, params css[] options)
    {
        var control = render(content, style, false, options);
        if (GUI.Button(control.rect, _getContent(content, options), _getStyle(style, options)))
            control.CustomMenuDisplay(index, variants().Select(strs).ToArray());
        if (control.CustomMenuApply(ref index) && index != -1)
            action(variants()[index]);
        return index;
    }

    public static int popup<T>(GUIContent content, int index, Func<IList<T>> variants, Func<T, string> strs, Action<T> action, params css[] options)
    {
        var control = render(content, "button", false, options);
        if (GUI.Button(control.rect, _getContent(content, options), _getStyle("button", options)))
            control.CustomMenuDisplay(index, variants().Select(strs).ToArray());
        if (control.CustomMenuApply(ref index) && index != -1)
            action(variants()[index]);
        return index;
    }

    public static int popup<T>(GUIContent content, int index, Func<IList<T>> variants, Func<T, string> strs, Action<T> action, string packOrStyle, params css[] options)
    {
        return popup<T>(content, index, variants, strs, action, _mergeOptions(packOrStyle, options));
    }

    public class _ControlInfo
    {
        internal _ControlInfo() {}

        public bool mayBeKeyboardFocus;
        public Rect rect;
        public int id;

        public EventType eventType { get { return Event.current.GetTypeForControl(id); }}

        public bool focused { get { return rect.Contains(Event.current.mousePosition); }}

        public bool keyDown { get { return Event.current.type == EventType.keyDown; }}
        public bool keyUp { get { return eventType == EventType.keyUp; }}
        
        public bool mouseLeft { get { return Event.current.button == 0; }}

        public void SetActive(bool value)
        {
            if (value)
            {
                GUIUtility.hotControl = id;
                if (mayBeKeyboardFocus)
                    GUIUtility.keyboardControl = id;
            }
            else
            {
                GUIUtility.hotControl = 0;
            }
        }

        public void CustomMenuDisplay(int selectedId, GUIContent[] variants)
        {
            EditorUtility.DisplayCustomMenu(rect, variants, selectedId, PopupCallback.SetValueStandart(id), null);
        }

        public void CustomMenuDisplay(GUIContent[] variants)
        {
            CustomMenuDisplay(-1, variants);
        }

        public void CustomMenuDisplay(int selectedId, string[] variants)
        {
            CustomMenuDisplay(selectedId, variants.Select(x => new GUIContent(x)).ToArray());
        }

        public void CustomMenuDisplay(string[] variants)
        {
            CustomMenuDisplay(-1, variants);
        }

        public void CustomMenuDisplay(int selectedId, List<GUIContent> variants)
        {
            EditorUtility.DisplayCustomMenu(rect, variants.ToArray(), selectedId, PopupCallback.SetValueStandart(id), null);
        }

        public void CustomMenuDisplay(List<GUIContent> variants)
        {
            CustomMenuDisplay(-1, variants);
        }

        public void CustomMenuDisplay(int selectedId, List<string> variants)
        {
            CustomMenuDisplay(selectedId, variants.Select(x => new GUIContent(x)).ToArray());
        }

        public void CustomMenuDisplay(List<string> variants)
        {
            CustomMenuDisplay(-1, variants);
        }

        public bool CustomMenuApply(ref int index)
        {
            if (!PopupCallback.Its(id))
                return false;
            index = PopupCallback.GetValue<int>();
            return true;
        }
    }

    public static class skins
    {
        public static GUISkin current { get { return GUI.skin; } set { GUI.skin = value; }}
        public static GUISkin inspector { get { return EditorGUIUtility.GetBuiltinSkin(EditorSkin.Inspector); } }
        public static GUISkin game { get { return EditorGUIUtility.GetBuiltinSkin(EditorSkin.Game); } }
        public static GUISkin scene { get { return EditorGUIUtility.GetBuiltinSkin(EditorSkin.Scene); } }
    }

    public static int selection_grid(int indexSelected, GUIContent[] contents, int xCount, GUIStyle style, params css[] options)
    {
        _actionsBefore(options);
        var result = GUILayout.SelectionGrid(indexSelected, _getContent(contents, options), xCount, _getStyle(style, options), _getOptions(options));
        _actionsAfter(options);
        return result;
    }

    public static int intfield(Rect rect, int value, GUIStyle style, params css[] options)
    {
        _actionsBefore(options);
        var result = EditorGUI.IntField(rect, value, _getStyle(style, options));
        _actionsAfter(options);
        return result;
    }

    public static int intfield(Rect rect, int value, params css[] options)
    {
        return intfield(rect, value, EditorStyles.numberField, options);
    }

    public static bool intfield(Rect rect, ref int value, GUIStyle style, params css[] options)
    {
        var result = intfield(rect, value, style, options);
        if (result != value)
        {
            value = result;
            return true;
        }
        return false;
    }

    public static bool intfield(Rect rect, ref int value, params css[] options)
    {
        return intfield(rect, ref value, EditorStyles.numberField, options);
    }

    public static int intfield(int value, GUIStyle style, params css[] options)
    {
        _actionsBefore(options);
        var result = EditorGUILayout.IntField(value, _getStyle(style, options), _getOptions(options));
        _actionsAfter(options);
        return result;
    }

    public static int intfield(int value, params css[] options)
    {
        return intfield(value, EditorStyles.numberField, options);
    }

    public static bool intfield(ref int value, GUIStyle style, params css[] options)
    {
        var result = intfield(value, style, options);
        if (result != value)
        {
            value = result;
            return true;
        }
        return false;
    }

    public static bool intfield(ref int value, params css[] options)
    {
        return intfield(ref value, EditorStyles.numberField, options);
    }

    //
    public static float floatfield(Rect rect, float value, GUIStyle style, params css[] options)
    {
        _actionsBefore(options);
        var result = EditorGUI.FloatField(rect, value, _getStyle(style, options));
        _actionsAfter(options);
        return result;
    }

    public static float floatfield(Rect rect, float value, params css[] options)
    {
        return floatfield(rect, value, "numberField", options);
    }

    public static bool floatfield(Rect rect, ref float value, GUIStyle style, params css[] options)
    {
        var result = floatfield(rect, value, style, options);
        if (result != value)
        {
            value = result;
            return true;
        }
        return false;
    }

    public static bool floatfield(Rect rect, ref float value, params css[] options)
    {
        return floatfield(rect, ref value, EditorStyles.numberField, options);
    }

    public static float floatfield(float value, GUIStyle style, params css[] options)
    {
        _actionsBefore(options);
        var result = EditorGUILayout.FloatField(value, _getStyle(style, options), _getOptions(options));
        _actionsAfter(options);
        return result;
    }

    public static float floatfield(float value, params css[] options)
    {
        return floatfield(value, EditorStyles.numberField, options);
    }

    public static bool floatfield(ref float value, GUIStyle style, params css[] options)
    {
        var result = floatfield(value, style, options);
        if (result != value)
        {
            value = result;
            return true;
        }
        return false;
    }

    public static bool floatfield(ref float value, params css[] options)
    {
        return floatfield(ref value, EditorStyles.numberField, options);
    }

    //==
    public static UnityEngine.Object objectfield(Rect rect, UnityEngine.Object value, bool allowSceneObject, params css[] options)
    {
        _actionsBefore(options);
        var result = EditorGUI.ObjectField(rect, value, value.GetType(), allowSceneObject);
        _actionsAfter(options);
        return result;
    }

    public static UnityEngine.Object objectfield(Rect rect, UnityEngine.Object value, params css[] options)
    {
        return objectfield(rect, value, true, options);
    }

    public static bool objectfield(Rect rect, ref UnityEngine.Object value, bool allowSceneObject, params css[] options)
    {
        var result = objectfield(rect, value, allowSceneObject, options);
        if (result != value)
        {
            value = result;
            return true;
        }
        return false;
    }

    public static bool objectfield(Rect rect, ref UnityEngine.Object value, params css[] options)
    {
        return objectfield(rect, ref value, true, options);
    }

    public static T objectfield<T>(T value, bool allowSceneObject, params css[] options) where T : UnityEngine.Object
    {
        _actionsBefore(options);
        var result = EditorGUILayout.ObjectField(value, value.GetType(), allowSceneObject, _getOptions(options));
        _actionsAfter(options);
        return result as T;
    }

    public static T objectfield<T>(T value, params css[] options) where T : UnityEngine.Object
    {
        return objectfield(value, true, options);
    }

    public static bool objectfield<T>(ref T value, bool allowSceneObject, params css[] options) where T : UnityEngine.Object
    {
        var result = objectfield(value, allowSceneObject, options);
        if (result != value)
        {
            value = result;
            return true;
        }
        return false;
    }

    public static bool objectfield<T>(ref T value, params css[] options) where T : UnityEngine.Object
    {
        return objectfield(ref value, true, options);
    }

    //
    public static Vector2 vectorfield(Vector2 vector, params css[] options)
    {
        _actionsBefore(options);
        var result = EditorGUILayout.Vector2Field(new GUIContent(), vector, _getOptions(options));
        _actionsAfter(options);
        return result;
    }

    public static Vector3 vectorfield(Vector3 vector, params css[] options)
    {
        _actionsBefore(options);
        var result = EditorGUILayout.Vector3Field(new GUIContent(), vector, _getOptions(options));
        _actionsAfter(options);
        return result;
    }

    public static Vector4 vectorfield(Vector4 vector, params css[] options)
    {
        _actionsBefore(options);
        var result = EditorGUILayout.Vector4Field("", vector, _getOptions(options));
        _actionsAfter(options);
        return result;
    }

    public static bool vectorfield(ref Vector2 vector, params css[] options)
    {
        var result = vectorfield(vector, options);
        if (result != vector)
        {
            vector = result;
            return true;
        }
        return false;
    }

    public static bool vectorfield(ref Vector3 vector, params css[] options)
    {
        var result = vectorfield(vector, options);
        if (result != vector)
        {
            vector = result;
            return true;
        }
        return false;
    }

    public static bool vectorfield(ref Vector4 vector, params css[] options)
    {
        var result = vectorfield(vector, options);
        if (result != vector)
        {
            vector = result;
            return true;
        }
        return false;
    }

    private static css[] _mergeOptions(string packname, css[] options)
    {
        var element = css.pack(packname, true);
        if (element == null)
        {
            var style = GUI.skin.GetStyle(packname);
            if (style == null)
                throw new Exception("Отсутствуют пак или стиль с именем '" + packname + "'");
            element = css.style(style);
        }

        if (options != null)
        {
            var l = options.ToList();
            l.Insert(0, element);
            return l.ToArray();
        }
        return new[] { element };
    }

    public static void setLastRect(ref Rect rect)
    {
        if (guievent.repaint)
        {
            if (rect == new Rect())
                Event.current.Use();
            rect = GUILayoutUtility.GetLastRect();
        }
    }

    public static int getControlId()
    {
        return GUIUtility.GetControlID(FocusType.Native);
    }

    public static int getControlId(FocusType focusType)
    {
        return GUIUtility.GetControlID(focusType);
    }




}