﻿using System.Collections.Generic;
using UnityEngine;

public static class guidata
{
    public static ControlData getOrCreate(int id)
    {
        ControlData value;
        if (datas.TryGetValue(id, out value))
            return value;
        value = new ControlData(id);
        datas.Add(id, value);
        return value;
    }

    public static ControlData getOrCreate(FocusType focusType)
    {
        var id = gui.getControlId(focusType);
        ControlData value;
        if (datas.TryGetValue(id, out value))
            return value;
        value = new ControlData(id);
        datas.Add(id, value);
        return value;
    }

    public class ControlData
    {
        internal ControlData(int id)
        {
            this.id = id;
        }

        public int id { get; private set; }
        public int idParent = -1;
        private Rect oldRect, newRect;
        public Rect rect { get { return oldRect; } private set { newRect = value; }}
        public object data;

        public T GetDataOrDefault<T>()
        {
            if (!(data is T))
            {
                data = default (T);
                return default(T);
            }
            return (T)data;
        }

        public void RegisterAsLastRect()
        {
            if (Event.current.type == EventType.repaint)
                rect = GUILayoutUtility.GetLastRect();
        }

        public void Apply()
        {
            if (Event.current.type == EventType.repaint)
                oldRect = newRect;
        }
    }

    private static Dictionary<int, ControlData> datas = new Dictionary<int, ControlData>();
    private static Dictionary<int, object> dictionary = new Dictionary<int, object>();
    private static Dictionary<int, Rect> dictionaryRects = new Dictionary<int, Rect>();
    private static Dictionary<int, Rect> dictionaryRectsNew = new Dictionary<int, Rect>();

    private static object Get(int id)
    {
        object value;
        if (dictionary.TryGetValue(id, out value))
            return value;
        return null;
    }

    private static Rect GetOldRect(int id)
    {
        Rect value;
        if (dictionaryRects.TryGetValue(id, out value))
            return value;
        return new Rect();
    }

    private static Rect GetNewRect(int id)
    {
        Rect value;
        if (dictionaryRectsNew.TryGetValue(id, out value))
            return value;
        return new Rect();
    }

    private static void SetNewRect(int id, Rect rect)
    {
        dictionaryRectsNew[id] = rect;
    }

    private static T Get<T>(int id)
    {
        object value;
        if (dictionary.TryGetValue(id, out value))
            return (T)value;
        return default(T);
    }

    private static void Set(int id, object value)
    {
        dictionary[id] = value;
    }

    public static Rect getLastRect()
    {
        var id = gui.getControlId(FocusType.Passive);
        if (id == -1)
            return new Rect();
        if (Event.current.type == EventType.Repaint)
        {
            var result = GUILayoutUtility.GetLastRect();
            Set(id, result);
            return result;
        }
        else
        {
            var result = Get(id);
            if (result == null)
            {
                Event.current.Use();
                return new Rect();
            }
            return (Rect)result; 
        }
    }

    public static void setLastRectAs(int id)
    {
        if (Event.current.type == EventType.repaint)
            SetNewRect(id, GUILayoutUtility.GetLastRect());
    }

    public static Rect getLastRectAs(int id)
    {
        return GetOldRect(id);
    }

    public static void applyRect(int id)
    {
        if (Event.current.type == EventType.repaint)
            dictionaryRects[id] = GetNewRect(id);
    }
}