﻿using UnityEngine;

public static class guievent
{
    public static void Default()
    {
        _e = Event.current;
    }

    public static void Pick(Event @event)
    {
        _e = @event;
    }

    private static Event _e;
    private static Event e
    {
        get
        {
            if (_e == null)
                Default();
            return _e;
        }
    }

    public static bool downLeft {get { return e.type == EventType.mouseDown && e.button == 0; }}
    public static bool downRight {get { return e.type == EventType.mouseDown && e.button == 1; }}
    public static bool downMiddle {get { return e.type == EventType.mouseDown && e.button == 2; }}
    public static bool downMouse {get { return e.type == EventType.mouseDown; }}

    public static bool upLeft { get { return e.type == EventType.mouseUp && e.button == 0; } }
    public static bool upRight { get { return e.type == EventType.mouseUp && e.button == 1; } }
    public static bool upMiddle { get { return e.type == EventType.mouseUp && e.button == 2; } }
    public static bool upMouse { get { return e.type == EventType.mouseUp; } }

    public static bool downKey { get { return e.type == EventType.keyDown; }}
    public static bool upKey { get { return e.type == EventType.keyUp; }}

    public static bool downKeyIs(KeyCode keyCode)
    {
        return downKey && e.keyCode == keyCode;
    }

    public static bool upKeyIs(KeyCode keyCode)
    {
        return upKey && e.keyCode == keyCode;
    }

    public static bool repaint { get { return e.type == EventType.repaint; }}

    public static void Use()
    {
        Event.current.Use();
    }

    public static Vector2 pos { get { return Event.current.mousePosition; }}
    public static Vector2 screenPos { get { return GUIUtility.GUIToScreenPoint(Event.current.mousePosition); }}

    public static bool ctrl { get { return e.control; }}
    public static bool shift { get { return e.shift; }}
    public static bool alt { get { return e.alt; }}

    public static bool useHotkeyDown(string hotkey)
    {
        hotkey = hotkey.ToLower();
        var parts = hotkey.Split('+');
        for (int i = 0; i < parts.Length; i++)
            parts[i] = parts[i].Trim();

        for (int i = 0; i < parts.Length; i++)
            if (parts[i].Length == 1)
            {
                if (!downKeyIs((KeyCode) parts[i][0]))
                    return false;
            }
            else
            {
                switch (parts[i])
                {
                    case "alt": if (!alt) return false; break;
                    case "control": case "ctrl": if (!ctrl) return false; break; 
                    case "shift": if (!shift) return false; break;
                    default:
                        for (int j = 0; j < parts[i].Length; j++)
                            if (!downKeyIs((KeyCode) parts[i][j])) return false; break;
                }
            }
        return true;
    }
    
    public static bool useHotkey(string hotkey)
    {
        hotkey = hotkey.ToLower();
        var parts = hotkey.Split('+');
        for (int i = 0; i < parts.Length; i++)
            parts[i] = parts[i].Trim();

        for (int i = 0; i < parts.Length; i++)
            if (parts[i].Length == 1)
            {
                if (e.keyCode != ((KeyCode)parts[i][0]))
                    return false;
            }
            else
            {
                switch (parts[i])
                {
                    case "alt": if (!alt) return false; break;
                    case "control":
                    case "ctrl": if (!ctrl) return false; break;
                    case "shift": if (!shift) return false; break;
                    default:
                        for (int j = 0; j < parts[i].Length; j++)
                            if (e.keyCode != ((KeyCode)parts[i][j])) return false; break;
                }
            }
        return true;
    }
}