﻿using System;
using UnityEngine;

[Serializable]
public class rect
{
    protected bool Equals(rect other)
    {
        return r.Equals(other.r);
    }

    public override bool Equals(object obj)
    {
        if (ReferenceEquals(null, obj)) return false;
        if (ReferenceEquals(this, obj)) return true;
        if (obj.GetType() != GetType()) return false;
        return Equals((rect) obj);
    }

    public override int GetHashCode()
    {
        return r.GetHashCode();
    }

    public Rect r;
    public float x { get { return r.x; }}
    public float y { get { return r.y; }}
    public float width { get { return r.width; }}
    public float height { get { return r.height; }}

    public rect()
    {
        r = new Rect();
    }

    public rect(float x, float y, float w, float h)
    {
        r = new Rect(x, y, w, h);
    }

    public rect(Vector2 pos, Vector2 size)
    {
        r = new Rect(pos.x, pos.y, size.x, size.y);
    }

    public rect(float x, float y, Vector2 size)
    {
        r = new Rect(x, y, size.x, size.y);
    }

    public rect(Vector2 pos, float w, float h)
    {
        r = new Rect(pos.x, pos.y, w, h);
    }

    public static implicit operator Rect(rect value)
    {
        return value.r;
    }

    public static bool operator ==(rect a, rect b)
    {
        return (a != null ? a.r : new Rect()) == (b != null ? b.r : new Rect());
    }

    public static bool operator !=(rect a, rect b)
    {
        return !(a == b);
    }

    public static rect operator +(rect a, rect b)
    {
        return new rect(a.x + b.x, a.y + b.y, a.width + b.width, a.height + b.height);
    }

    public static rect operator -(rect a, rect b)
    {
        return new rect(a.x - b.x, a.y - b.y, a.width - b.width, a.height - b.height);
    }
}