﻿using UnityEngine;

namespace xgm.guru.w3_to_unity
{
    /// <summary>
    /// Содержит все глобальные константы
    /// </summary>
    internal static class MdxConsts
    {
        /// <summary> Недопустимый идентификатор </summary>
        public const int InvalidId = -1;

        /// <summary> Недопустимый индекс </summary>
        public const int InvalidIndex = -1;

        /// <summary> Версия моделей War3 по умолчанию </summary>
        public const int DefaultModelVersion = 800;

        /// <summary>
        /// The default blend time, for WarCraft 3 models.
        /// </summary>
        public const int DefaultModelBlendTime = 150;

        internal const int SizeTag = 4;
        internal const int SizeName = 80;
        internal const int SizeFileName = 260;

        internal static readonly Vector2 DefaultVector2 = new Vector2();
        internal static readonly Vector3 DefaultVector3 = new Vector3();
        internal static readonly Vector4 DefaultVector4 = new Vector4();
        internal static readonly Extent DefaultExtent = new Extent();
        internal static readonly Primitives.CInterval DefaultInterval = new Primitives.CInterval();
        internal static readonly Primitives.CSegment DefaultSegment = new Primitives.CSegment();

        internal static readonly Vector3 DefaultTranslation = Vector3.zero;
        internal static readonly Quaternion DefaultRotation = Quaternion.identity;
        internal static readonly Vector3 DefaultScaling = new Vector3(1, 1, 1);
        internal static readonly Color DefaultColor = new Color(1, 1, 1);

        internal static System.Text.Encoding TextEncoding = System.Text.Encoding.UTF8;
        internal static System.Text.Encoding SimpleTextEncoding = System.Text.Encoding.ASCII;
        internal static System.Globalization.NumberFormatInfo NumberFormat = System.Globalization.NumberFormatInfo.InvariantInfo;
    }
}
